SystemOrganization addCategory: #SOULLoader!

Object subclass: #SOULLoader
	instanceVariableNames: 'username password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOULLoader'!

!SOULLoader commentStamp: '<historical>' prior: 0!
To load SOUL, LiCoR and the required dependencies, do a do-it on:

	SOULLoader new loadPackages!

!SOULLoader class methodsFor: 'as yet unclassified' stamp: 'JB 6/10/2009 10:28'!
initialize

		('Pharo*' match: SystemVersion current version) 
			ifTrue:[self new loadPackagesForPharo]
			ifFalse: [self new loadPackagesForSqueak]! !

!SOULLoader methodsFor: 'loading' stamp: 'AndyKellens 11/30/2009 14:49'!
loadGlamour
	self loadLatestPackage: 'GlamourLoader' from:
			'http://www.squeaksource.com/Glamour/'.
	(Smalltalk at:#GlamourConfig) new load.
	self loadLatestPackage: 'Morphic-MorphTreeWidget' from:
			'http://www.squeaksource.com/Momo/'.
	
! !

!SOULLoader methodsFor: 'loading' stamp: 'sp 12/5/09 13:30'!
loadLatestPackage: aString from: aPath
	
	| repository versionsBlock versions tries version |
	repository _ MCHttpRepository location: aPath user: '' password: ''.
	versionsBlock _ [(repository allVersionNames
		select: [:each | each beginsWith: aString])
		asSortedCollection:
			[:a :b | (a copyAfterLast: $.) asNumber <= (b copyAfterLast: $.) asNumber]]
		fixTemps.
	versions _ versionsBlock value.
	tries _ 0.
	[versions isEmpty and: [tries < 3]]
		whileTrue:
			[versions _ versionsBlock value.
			tries _ tries + 1].
	versions isEmpty
		ifTrue: [self error: 'problems when accessing squeaksource'].
	version _ (repository versionReaderForFileNamed: versions last , '.mcz')
		version.
	version load.
	version workingCopy repositoryGroup addRepository: repository! !

!SOULLoader methodsFor: 'loading' stamp: 'sp 12/5/09 13:30'!
loadPackage: aBlock from: aPath
	
	| repository versions tries version |
	repository _ MCHttpRepository location: aPath user: '' password: ''.
	versions _ aBlock value: repository.
	tries _ 0.
	[versions isEmpty and: [tries < 3]]
		whileTrue:
			[versions _ aBlock value: repository.
			tries _ tries + 1].
	versions isEmpty
		ifTrue: [self error: 'problems when accessing squeaksource'].
	version _ (repository versionReaderForFileNamed: versions last , '.mcz')
		version.
	version load.
	repository _ MCRepositoryGroup default repositories
		detect:
			[:each | 
			(each isKindOf: MCHttpRepository)
				and:
					[each locationWithTrailingSlash = repository locationWithTrailingSlash]]
		ifNone: [repository].
	version workingCopy repositoryGroup addRepository: repository! !

!SOULLoader methodsFor: 'loading' stamp: 'sp 12/5/09 13:30'!
loadPackage: aString from: aPath version: versNumber
	
	self
		loadPackage:
			[:repository | 
			(repository allVersionNames select: [:each | each beginsWith: aString])
				select: [:name | (name copyAfterLast: $-) = versNumber]] fixTemps
		from: aPath! !

!SOULLoader methodsFor: 'loading' stamp: 'JohanBrichau 10/30/2009 14:45'!
loadPackages
	
	"self loadPackage: 'AST-' from: 'http://www.squeaksource.com/AST/' version:
			'md.125'."
	self loadPackage: 'SmaCC-' from:
			'http://www.squeaksource.com/SmaccDevelopment/' version: 'lr.13'.
	"self loadPackage: 'NewCompiler-' from:
			'http://www.squeaksource.com/NewCompiler/' version: 'md.169'.
	self loadPackage: 'RefactoringEngine-' from:
			'http://www.squeaksource.com/RefactoringEngine/' version: 'dc.30'."
	self loadPackage: 'SmaCCDev-' from:
			'http://www.squeaksource.com/SmaccDevelopment/' version: 'lr.17'.
	"Preferences setPreference: #compileBlocksAsClosures toValue: true."
	self loadLatestPackage: 'SOUL-' from:
			'http://www.squeaksource.com/SqueakSoul/'.
	self loadLatestPackage: 'Soul-Primitives-' from:
			'http://www.squeaksource.com/SqueakSoul/'.
	self loadLatestPackage: 'LiCoR-' from:
			'http://www.squeaksource.com/SqueakSoul/'.
	Factory initializeRepositories.
	MLIForSqueak setAsCurrentMLI.
	Factory createLiCoRRepositories! !

!SOULLoader methodsFor: 'loading' stamp: 'AndyKellens 11/30/2009 14:07'!
loadPackagesForPharo
	self loadGlamour.
	self loadPackage: 'SmaCC-' from:
			'http://www.squeaksource.com/SmaccDevelopment/' version: 'lr.13'.
	"self loadPackage: 'SmaCCDev-' from:
			'http://www.squeaksource.com/SmaccDevelopment/' version: 'lr.17'."
	self loadLatestPackage: 'SOUL-' from:
			'http://www.squeaksource.com/SqueakSoul/'.
	self loadLatestPackage: 'Soul-Primitives-' from:
			'http://www.squeaksource.com/SqueakSoul/'.
	self loadLatestPackage: 'LiCoR-' from:
			'http://www.squeaksource.com/SqueakSoul/'.
	self loadLatestPackage: 'SOUL-PharoSpecific' from:
		'http://www.squeaksource.com/SqueakSoul/'.
	Factory initializeRepositories.
	MLIForSqueak setAsCurrentMLI.
	Factory createLiCoRRepositories! !

!SOULLoader methodsFor: 'loading' stamp: 'JohanBrichau 10/30/2009 14:49'!
loadPackagesForSqueak
	
	self loadPackage: 'AST-' from: 'http://www.squeaksource.com/AST/' version:
			'md.125'.
	self loadPackage: 'SmaCC-' from:
			'http://www.squeaksource.com/SmaccDevelopment/' version: 'lr.13'.
	self loadPackage: 'NewCompiler-' from:
			'http://www.squeaksource.com/NewCompiler/' version: 'md.169'.
	self loadPackage: 'RefactoringEngine-' from:
			'http://www.squeaksource.com/RefactoringEngine/' version: 'dc.30'.
	"self loadPackage: 'SmaCCDev-' from:
			'http://www.squeaksource.com/SmaccDevelopment/' version: 'lr.17'."
	Preferences setPreference: #compileBlocksAsClosures toValue: true.
	self loadLatestPackage: 'SOUL-' from:
			'http://www.squeaksource.com/SqueakSoul/'.
	self loadLatestPackage: 'Soul-Primitives-' from:
			'http://www.squeaksource.com/SqueakSoul/'.
	self loadLatestPackage: 'LiCoR-' from:
			'http://www.squeaksource.com/SqueakSoul/'.
	Factory initializeRepositories.
	MLIForSqueak setAsCurrentMLI.
	Factory createLiCoRRepositories! !
SOULLoader initialize!
